<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.9.2/css/bulma.min.css">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css"
        integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    <style>
        #chartdiv {
            width: 100%;
            height: 300px;
        }
    </style>
    <script src="https://canvasjs.com/assets/script/canvasjs.min.js"></script>
    <script src="https://cdn.amcharts.com/lib/5/index.js"></script>
    <script src="https://cdn.amcharts.com/lib/5/percent.js"></script>
    <script src="https://cdn.amcharts.com/lib/5/themes/Animated.js"></script>
    <title>⚡ ciscojmg</title>
</head>

<body>
    <div class="container">
        <nav class="navbar" role="navigation" aria-label="main navigation">
            <div class="navbar-brand">
                <a class="navbar-item" href="https://gitlab.com/ciscojmg">
                    ⚡ <strong>ciscojmg</strong>
                </a>
            </div>
        </nav>
        <div class="columns">
            <div class="column is-two-thirds">
                <div class="card">
                    <div class="card-content">
                        <div class="content">
                            <p class=""><strong>🦐 Sensor IR Tolva bioFeeder</strong></p>
                            <div>
                                <canvas id="myChart"></canvas>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="column is-one-third">
                <div class="card">
                    <div class="card-content">
                        <div class="content">
                            <p class=""><strong>🦐 Tolva</strong></p>
                            <div class="chart-container">
                                <div id="chartdiv"></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.0.2/chart.min.js"></script>
    <script src="/socket.io/socket.io.js" charset="utf-8"></script>

    <script>
        var level = [0];

        const socket = io();
        var ctx = document.getElementById('myChart').getContext("2d");
        var gradientStroke = ctx.createLinearGradient(0, 230, 0, 50);

        gradientStroke.addColorStop(1, 'rgba(29,140,248,0.2)');
        gradientStroke.addColorStop(0.4, 'rgba(29,140,248,0.0)');
        gradientStroke.addColorStop(0, 'rgba(29,140,248,0)'); //blue colors
        var chart = new Chart(ctx, {
            type: 'bar',
            data: {
                labels: ['1', '2', '3', '4'],
                datasets: [{
                    data: ['500','500','500','500'],
                    borderWidth: 2,
                    borderRadius: 10,
                    borderSkipped: false,
                    fill: true,
                    backgroundColor: gradientStroke,
                    hoverBackgroundColor: gradientStroke,
                    borderColor: '#1f8ef1',
                    borderDash: []

                }]
            },
            options: {
                responsive: true,
                title: {
                    display: true,
                    text: 'My Chart'
                },
                scales: {
                    y: {
                        max: 900,
                        reverse: true
                    }
                },
                plugins: {
                    legend: false,
                }
            }
        });

        socket.on('arduino:data', function (dataSerial) {
            var dataSerialArray = dataSerial.value.split(" ");
            // console.log(dataSerialArray);
            let backgroundColor = ['#95a5a6', '#95a5a6', '#95a5a6', '#95a5a6', '#95a5a6'];

            dataSerialArray.forEach(function (valor, indice, array) {
                if (valor <= 100) { backgroundColor[indice] = '#1E88E5'; }
                else if ((110 <= valor) && (valor <= 200)) { backgroundColor[indice] = '#2196F3'; }
                else if ((210 <= valor) && (valor <= 350)) { backgroundColor[indice] = '#42A5F5'; }
                else if ((360 <= valor) && (valor <= 550)) { backgroundColor[indice] = '#64B5F6'; }
                else if ((560 <= valor) && (valor <= 750)) { backgroundColor[indice] = '#90CAF9'; }
                else if ((760 <= valor) && (valor <= 810)) { backgroundColor[indice] = '#BBDEFB'; }

            });

            chart.data.datasets.forEach(function (dataset) {
                dataset.data = dataSerialArray;
                // dataset.backgroundColor = backgroundColor;

            });
            chart.update();
        });

        am5.ready(function () {

            // Create root element
            // https://www.amcharts.com/docs/v5/getting-started/#Root_element
            var root = am5.Root.new("chartdiv");


            // Set themes
            // https://www.amcharts.com/docs/v5/concepts/themes/
            root.setThemes([am5themes_Animated.new(root)]);


            // Create chart
            // https://www.amcharts.com/docs/v5/charts/percent-charts/sliced-chart/
            var chart = root.container.children.push(am5percent.SlicedChart.new(root, {
                layout: root.verticalLayout
            }));


            // Create series
            // https://www.amcharts.com/docs/v5/charts/percent-charts/sliced-chart/#Series
            var series = chart.series.push(am5percent.PictorialStackedSeries.new(root, {
                alignLabels: false,
                orientation: "vertical",
                valueField: "value",
                categoryField: "category",
                svgPath:
                    "M782.04774,432.84676h-16.75164l-41.8604,-41.8604v-57.03723v0h100.47244v0v57.03723z M734.82415,328.24833h69.19685v5.70079h-69.19685z M734.82415,328.24833h69.19685v5.70079h-69.19685z M791.54855,328.16434v-7.81102l-41.00787,7.81102z M791.54855,328.16434v-7.81102l-41.00787,7.81102z M792.18373,328.16434v-7.81102l11.96851,7.81102z"
            }));

            series.labelsContainer.set("width", 100);
            series.ticks.template.set("location", 0.6);


            // Set data
            // https://www.amcharts.com/docs/v5/charts/percent-charts/sliced-chart/#Setting_data
            series.data.setAll([
                { category: "F", value: 40 },
                { category: "O", value: 60 }
            ]);


            // Add legend
            // https://www.amcharts.com/docs/v5/charts/xy-chart/legend-xy-series/
            chart.set("layout", root.verticalLayout);

            var legend = chart.children.moveValue(am5.Legend.new(root, {
                paddingBottom: 15,
                paddingTop: 15,
                x: am5.percent(50),
                dx: 10,
                centerX: am5.p50
            }), 0);

            legend.markers.template.setAll({ width: 30, height: 30 });
            legend.markerRectangles.template.setAll({
                cornerRadiusBL: 20,
                cornerRadiusBR: 20,
                cornerRadiusTL: 20,
                cornerRadiusTR: 20
            });

            legend.data.setAll(series.dataItems);


            // Play  initial se ries animation
            // https://www.amcharts.com/docs/v5/concepts/animations/#Animation_of_series
            chart.appear(1000, 100);
            var le = 0;
            const socket = io();
            socket.on('arduino:data', function (dataSerial) {
                var data = dataSerial.value.split(" ");
                level[0] = (parseInt(data[0], 10) + parseInt(data[1], 10) + parseInt(data[2], 10) + parseInt(data[3], 10)) / 5;
                level[0] = parseInt(Math.abs(level[0] - 900) / 10,10);
        

                // if ((0 <= level[0]) && (level[0] <= 350)) { level[0] = 5; }
                // else if ((351 <= level[0]) && (level[0] <= 400)) { level[0] = 10; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 20; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 30; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 40; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 50; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 60; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 70; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 80; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 90; }
                // else if ((110 <= level[0]) && (level[0] <= 200)) { level[0] = 95; }
                console.log(level[0]);

                series.data.setIndex(0, {
                    category: "Free",
                    value: 100 - level[0]


                });

                series.data.setIndex(1, {
                    category: "O",
                    value: level[0]
                });

            });

        }); // end am5.ready()





    </script>
</body>

</html>